package com.dky.calculate;

import com.dky.utils.entity.SysDeviceHeatScene;
import com.dky.utils.result.MatchedDevice;
import java.util.ArrayList;
import java.util.List;

public class Scheme {

    public List<MatchedDevice> calSchemeByTechType(Double buildArea, List<SysDeviceHeatScene> deviceList, String techType){

        List<SysDeviceHeatScene> list = new ArrayList();
        for (int i = 0; i < deviceList.size(); i++){
            if (deviceList.get(i).getDevTechType().equals(techType)){
                list.add(deviceList.get(i));
            }
        }
        //对list按照单台设备可参考供暖面积进行排序
        list.sort((o1, o2) -> Double.compare(o2.getDevReferenceArea(),o1.getDevReferenceArea()));
        Double remainArea = buildArea;
        //遍历设备，根据建筑面积进行匹配设备数量
        List<MatchedDevice> matchedDeviceList = new ArrayList();
        for (SysDeviceHeatScene deviceHeatScene:list){
            if (deviceHeatScene.getDevReferenceArea() <= remainArea){
                int count = (int) (buildArea/deviceHeatScene.getDevReferenceArea());
                remainArea = remainArea - count*deviceHeatScene.getDevReferenceArea();
                matchedDeviceList.add(new MatchedDevice(deviceHeatScene,count));
            }
            if (remainArea <= 0) {
                break; // 当总供暖面积已经满足需求时，跳出循环，不再选择其他设备
            }
        }
        return matchedDeviceList;
    }
}
